% DM - TP 3 : Analyse en composantes principales
% Auteurs : Florian Boitrel - Maxime Chambreuil
% Date : 19 Mars 2003

%%%%%%%%%%
% ENTREE : 
% X : Matrice des individus et des variables
% nbCompos : Nombre de composantes souhaitees

%%%%%%%%%%
% SORTIE :
% epsilon : Matrice d'individus sur les composantes principales
% U : La matrice des composantes principales

function [epsilon,U] = acp(X,nbCompos)

N = length(X);

%%%%%%%%%%%%%%%%%%%%
% Boite a moustaches
% figure;
% boxplot(X);
% xlabel('Variables de X');
% title('Boites a moustaches des variables de X');

%%%%%%%%%%%%%%%%%%%%
% Compo versus compo
% multiplot(X);

%%%%%%%%%%%%%%%%%%%%%%%%
% On centre ET on rduit
Xcr=(X-ones(N,1)*mean(X))./(ones(N,1)*std(X));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calcul des valeurs et des vecteurs propres
[v,l]=eig(Xcr'*Xcr);

%%%%%%%%%%%%%%%%%%%%%%%%
% Extraction du nbCompos
[lmax indices]=sort(max(l));
U = [];
for i=0:size(X,2)-1
     U=[U v(:,indices(length(indices))-i)];
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calcul de X sur les compo principales
epsilon=X*U;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Affichage des 2 compo principales
% figure;
% plot(epsilon(:,1),epsilon(:,2),'x');
% title('X selon ses 2 composantes principales');
% xlabel('1ere Composante');
% ylabel('2eme Composante');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Affichage des 3 compo principales
% figure;
% plot3(epsilon(:,1),epsilon(:,2),epsilon(:,3),'x');
% grid on;
% title('X selon ses 3 composantes principales');
% xlabel('1ere Composante');
% ylabel('2eme Composante');
% zlabel('3eme Composante');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Affichage des contributions
% figure;
% t=0:0.01:2*pi;
% plot3(cos(t),sin(t),zeros(length(t),1));hold on;
% plot3(zeros(length(t),1),cos(t),sin(t));hold on;
% plot3(sin(t),zeros(length(t),1),cos(t));hold on;
% grid on;
% for i=1:5
%      plot3(U(i,1),U(i,2),U(i,3),'+r');
%      text(U(i,1)+0.05,U(i,2)+0.05,U(i,3)+0.05,num2str(i));
% end
% title('Contribution des variables de X dans les composantes principales');
% xlabel('1ere composante');
% ylabel('2eme composante');
% zlabel('3eme composante');

U = U(:,1:nbCompos);
epsilon = epsilon(:,1:nbCompos);
